SystemOrganization addCategory: #'Pier-Fame'!

PRStructure subclass: #PFMetamodel
	instanceVariableNames: 'metamodelString metamodel imageForm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Fame'!

!PFMetamodel class methodsFor: 'as yet unclassified' stamp: 'tg 6/20/2008 00:22'!
descriptionMetamodelString
	^ MAMemoDescription new
		selectorAccessor: #metamodelString;
		priority: 1000;
		label: 'Metamodel in MSE format';
		beEditable;
		yourself! !

!PFMetamodel class methodsFor: 'as yet unclassified' stamp: 'tg 6/20/2008 00:20'!
isAbstract
	^false! !

!PFMetamodel methodsFor: 'as yet unclassified' stamp: 'tg 12/21/2009 03:17'!
fameShape
	| builder bodyLabel |
		builder := MOFormsBuilder new.
			builder column; fill.
				builder row; fill; row; fill.
					builder x: 1 y: 1 add: (MORectangleShape new text: [ :cls | cls name ]).
						builder x: 1 y: 2 add: MORectangleShape new.
							bodyLabel :=  [ :cls | | label | 
											label := cls attributes 
															inject: ''
																			into: [ :sum :el | sum ,(self propertyLabel: el) , String cr ].
																							label copyFrom: 1 to: ((label size -1) max: 0)   ].
																							builder x: 1 y: 2 add: (MOLabelShape new text: bodyLabel).
																								^ builder shape! !

!PFMetamodel methodsFor: 'as yet unclassified' stamp: 'tg 3/24/2009 15:53'!
imageForm

	^ imageForm ifNil: [MOCanvas new imageForm]! !

!PFMetamodel methodsFor: 'as yet unclassified' stamp: 'tg 6/20/2008 00:29'!
metamodel

	^metamodel! !

!PFMetamodel methodsFor: 'as yet unclassified' stamp: 'tg 6/20/2008 00:23'!
metamodelString

	^metamodelString! !

!PFMetamodel methodsFor: 'as yet unclassified' stamp: 'tg 12/21/2009 03:15'!
metamodelString: aString

	| view canvas |
	metamodelString := aString.
	
	metamodel := FMTower new metamodel.
	metamodel importString: metamodelString.

	view := MOViewRenderer new.
	self viewFameMetaModel: metamodel on: view.
	canvas := MOCanvas new. 
	canvas root: view root.	
	imageForm := canvas imageForm.

	
"	(FMMSEParser 
		parse: aString
		using: FMMetaRepository fm3) asMetarepository.	
"! !

!PFMetamodel methodsFor: 'as yet unclassified' stamp: 'tg 12/21/2009 03:17'!
propertyLabel: aFM3Property
	
	^ String streamContents: [ :str |
				( aFM3Property isDerived ) ifTrue: [ str nextPut: $/ ].
						str nextPutAll: aFM3Property name copy.
								str nextPut: $: ; nextPut: $ ; nextPutAll: aFM3Property type name.
										( aFM3Property isMultivalued ) ifTrue: [ str nextPut: $* ].
												( aFM3Property hasOpposite ) ifTrue: [ str nextPutAll: ' -> ', aFM3Property opposite name ]		
															]! !

!PFMetamodel methodsFor: 'as yet unclassified' stamp: 'tg 3/24/2009 15:17'!
viewComponentClass
	^ PFMetamodelHtmlView! !

!PFMetamodel methodsFor: 'as yet unclassified' stamp: 'tg 12/21/2009 03:16'!
viewFameMetaModel: metamodel on: view.
	view interaction draggable.
		view interaction item: 'Export as PNG' action: [:each | view asMorph exportAsPNG ].
			view shape: self fameShape.
				view nodes: metamodel classes.
					view edgeShape:  MOOrthoHorizontalLineShape new.
						view edgesFrom: #superclass.
							view layout: (MOHorizontalDominanceTreeLayout new verticalGap: 10)! !

PRDefaultView subclass: #PFMetamodelHtmlView
	instanceVariableNames: 'mm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Fame'!

!PFMetamodelHtmlView methodsFor: 'as yet unclassified' stamp: 'tg 3/24/2009 15:19'!
mm
	^ mm ifNil: [ mm := self find: PFMetamodel ]! !

!PFMetamodelHtmlView methodsFor: 'as yet unclassified' stamp: 'tg 3/24/2009 15:51'!
renderContentOn: html

	html image
		form: self mm imageForm.
	


"	metamodel packages do: [:each | 
		html div class: 'mmPackage'; with: each name.
		each classes do: [:cls | 
			html div class: 'mmClass'; with: cls name.
			cls attributes do: [:prop |
				html div class: 'mmProp'; with: prop name, ': ', prop type fullName
			]
		]
	]."! !
